/*  Program to set up input file for disloced by prompting the user  */

#include <stdio.h>
#include <math.h>

main()
{
   char ibuff[80],landmu[80],displace[80],landw[80],depanddip[80];
   int  i,j,k,inx,iny;
   float x1,y1,z1,x2,y2,z2,xc,yc,xcoord,ycoord,strike,depth,dip,isx,isy;
   float xslope,yslope,zslope,xyslope,yyslope,zyslope,length,width;
   FILE *fd;
   printf("Input file name:  ");
   gets(ibuff);
   if ((fd = fopen(ibuff,"w")) == NULL)
      {
      printf("SORRY cannot open %s\n\n",ibuff);
      exit(0);
      }
   printf("Input latitude and longitude of origin:  ");
   gets(ibuff);
   fprintf(fd,"%s  ",ibuff);
/*   printf("      longitude of origin:  ");
   gets(ibuff);
   fprintf(fd,"%s  ",ibuff);*/
   printf("      generation parameter:  ");
   gets(ibuff);
   sscanf(ibuff,"%d",&i);
   fprintf(fd,"%d  ",i);
   if (!i)
      {
      printf("\n***Grid will not be generated***\n    Input number of points:  ");
      gets(ibuff);
      sscanf(ibuff,"%d\n",&j);
      fprintf(fd,"%d \n",j);
      for (k=0; k < j; ++k)
	 {
	 if (!k)
	    printf("Input x y coords:  ");
	 else
	    printf("             x y:  ");
	 gets(ibuff);
	 fprintf(fd,"%s \n",ibuff);
	 }
      }
   else
      {
      printf("\n             ***Grid will be generated***\n");
      printf("Input first x coord, x increment, # to increment in x direction:  ");
      gets(ibuff);
      fprintf(fd,"\n%s  ",ibuff);
      printf("Input first y coord, y increment, # to increment in y direction:  ");
      gets(ibuff);
      fprintf(fd,"%s  \n",ibuff);
      }
   printf("\nInput x coord  y coord strike of fault:  ");
   while (gets(ibuff) != NULL)
      {
      sscanf(ibuff,"%f %f %f",&xcoord,&ycoord,&strike);
      printf("\nInput type of fault (0=point source, 1=rectangular fault,\n 2=linear interpolation of displacement on rectangular fault):  ");
      gets(ibuff);
      sscanf(ibuff,"%d\n",&i);
      printf("Input depth and dip of fault:  ");
      gets(depanddip);
      printf("Input lambda and mu:  ");
      gets(landmu);
      if(i<2)
        {
        fprintf(fd,"%g %g %g  \n",xcoord,ycoord,strike);
        printf("Input strike-slip  dip-slip  tensile displacements:  ");
        gets(displace);
        fprintf(fd,"%d  %s  %s  ",i,depanddip,landmu);
        fprintf(fd,"%s  ",displace);
        printf("Input length and width of fault:  ");
        gets(landw);
        fprintf(fd,"%s \n",landw);
        } 
      else
        {
        sscanf(depanddip,"%f %f",&depth,&dip);
        printf("Input strike-slip  dip-slip  tensile displacements at origin:  ");
        gets(displace);
        sscanf(displace,"%f %f %f",&x1,&y1,&z1);
        printf("\n(Dip-slip interpolated along dip, strike-slip interpolated along strike\n");
        printf("tensile displacement not interpolated)\n");
        printf("Input strike-slip  dip-slip  displacements at extent:  ");
        gets(displace);
        sscanf(displace,"%f %f",&x2,&y2);
        printf("Input length and width of fault:  ");
        gets(landw);
        sscanf(landw,"%f %f",&length,&width);
        printf("Input interpolation grid size x y directions\n");
        printf("                    (Any extra is not used):  ");
        gets(ibuff);
        sscanf(ibuff,"%f %f",&isx,&isy);
        inx = length/isx; iny = width/isy;
        xslope = ((length == isx) ? 0.0 : (x2-x1)/(length-isx));
        yslope = ((width == isy) ? 0.0 : (y2-y1)/(width-isy));
        for (i=0; i<iny; ++i)
          for(j=0; j<inx; ++j)
	    {
            xc = isx*(float)j;
            yc = isy*(float)i;
            rotate(&xc,&yc,(90-strike));
            fprintf(fd,"%g %g %g\n",(xc+xcoord),(yc+ycoord),strike);
            fprintf(fd,"1 %g %g %s %g %g %g %g %g\n",(depth-isy*(float)i*sin(dip)),
                    dip,landmu,
                    (xslope*isx*(float)j+x1),(yslope*isy*(float)i+y1),
                    z1,isx,isy);
            }
        }
      printf("Input x coord  y coord strike of fault\n");
      printf("                  or control-D to exit:\n");
      }
}
rotate(x,y,alpha)
float *x, *y, alpha;
{
   float xp,yp,d2r;

   d2r = acos(-1.0)/180.0;
   xp = *x*cos(d2r*alpha) - *y*sin(d2r*alpha);
   yp = *x*sin(d2r*alpha) + *y*cos(d2r*alpha);
   *x=xp; *y=yp;
}
